

#include <16LF727.h>


//////// Fuses: LP,XT,HS,EC_IO,INTRC_IO,INTRC,RC_IO,RC,NOWDT,WDT,NOPUT,PUT
//////// Fuses: NOMCLR,MCLR,NOPROTECT,PROTECT,NOBROWNOUT,BROWNOUT_NOSL
//////// Fuses: NOBROWNOUT,BORV25,BORV19,NOPLLEN,PLLEN,DEBUG,NODEBUG,VCAP_A0
//////// Fuses: VCAP_A5,VCAP_A6,NOVCAP


//#device ICD=TRUE
//#device adc=8
//#FUSES DEBUG 
#FUSES NOWDT                 	//No Watch Dog Timer
#FUSES INTRC_IO              	//Internal RC Osc, no CLKOUT
#FUSES NOPUT                 	//No Power Up Timer
#FUSES MCLR                  	//Master Clear pin enabled
#FUSES NOPROTECT             	//Code not protected from reading
#FUSES NOBROWNOUT            	//No brownout reset
//#FUSES BORV19     
          
//#FUSES PLLEN         
#define delay_val 200     
#FUSES NOVCAP                
#use delay(clock=8000000)
#include <mylcd.h>
#byte ANSELA = 0x185

//#define INIT8BIT

void init_8_bit_mode()
{
//### just turn on display, cursor, blink-mode and LCD ready to display.
lcd_send_byte(0x0F);
}

void init_4_bit_mode()
{
///### initilize as per data-sheet.
lcd_send_nibble(0x30);
lcd_send_nibble(0x30);
lcd_send_nibble(0x30);

//### send initial function set as still LCD is in 8-bit mode.
lcd_send_nibble(0x20);

//### send function set again,  4-bit mode, 2 line LCD , JHD162A
lcd_send_byte(0x28);

//### turnon display, cursor, blink-mode
lcd_send_byte(0x0F);

//### Clear display 
lcd_send_byte(0x01);
//### Entry mode, increment, shift=0
lcd_send_byte(0x06);

}


void main()
{
//### Digital IO
ANSELA = 0x00;

///Turn off both the debug LDEs
output_bit (RED_LED, 1);
output_bit (GREEN_LED, 1);

//### Initial delay for LCD to stable
delay_ms(delay_val);

//### write enable
output_bit(LCD_RW, 0);
//### switch to instruction mode
output_bit(LCD_RS, 0);

//#### Call 8-bit init
#ifdef INIT8BIT
init_8_bit_mode();
#else
//#### Call 4-bit init
init_4_bit_mode();
#endif

//### init over, glow green debug led
output_bit(GREEN_LED, 0);
//### switch to data_mode
output_bit(LCD_RS, 1);

// Start sending DATA now

//################ data
lcd_send_byte(0x1F);
//################ data
lcd_send_byte(0x2f);
//################ data
lcd_send_byte(0x3f);
//################ data
lcd_send_byte(0x4f);
//################ data
lcd_send_byte(0x5f);
//################ data
lcd_send_byte(0x6f);
//################ data
lcd_send_byte(0x7f);
//################ data
lcd_send_byte(0x8f);
//################ data
lcd_send_byte(0x9f);

	while(1)
	{
	  //### Glow RED led to indicate all data sent to LCD
	  output_bit (RED_LED, 0);
	  delay_ms(500);
	}
}
	

